ad_library {

    Implementation of dotlrn_applet for the Todo application
}

namespace eval dotlrn_todo {}

ad_proc -public dotlrn_todo::get_pretty_name {
} {
    returns the pretty name
} {
    return "#dotlrn-todo.applet_pretty_name#"
}


ad_proc -public dotlrn_todo::clone {
    old_community_id
    new_community_id
} {

    Clone this applet's content from the old community to the new one

} {

    set old_package_id [dotlrn_community::get_applet_package_id -community_id $old_community_id -applet_key "dotlrn_todo"]
        
    set portal_id [dotlrn_community::get_portal_id -community_id $new_community_id]
    set package_id [dotlrn::instantiate_and_mount $new_community_id "todo"]

    # add the portlet

    dotlrn_todo::add_self_to_page \
        -portal_id $portal_id \
        -package_id $package_id \
        -param_action overwrite

    return $package_id
    
}

ad_proc -public dotlrn_todo::change_event_handler {
    community_id
    event
    old_value
    new_value
} {
    Not implemented
} {
    return
}


ad_proc -public dotlrn_todo::add_applet {
} {
	Used for one-time init - must be repeatable!
} {
    dotlrn_applet::add_applet_to_dotlrn \
        -applet_key "dotlrn_todo" \
        -package_key "dotlrn-todo"
}

ad_proc -public dotlrn_todo::add_portlet {
    portal_id
} {
    Adds a porlet.
} {

    todo_portlet::add_self_to_page \
        -portal_id $portal_id \
        -package_id 0 \
        -param_action "overwrite"

}

ad_proc -public dotlrn_todo::add_applet_to_community {
    community_id
} {
    Add the applet to a specifc dotlrn community
} {

    set portal_id [dotlrn_community::get_portal_id -community_id $community_id]
    set package_id [dotlrn::instantiate_and_mount $community_id "todo"]

    # add the portlet
    todo_portlet::add_self_to_page \
        -portal_id $portal_id \
        -package_id $package_id \
        -param_action "overwrite"

    return $package_id

}
    
ad_proc -public dotlrn_todo::add_user {
    user_id
} {
    No-op
} {
    return
}

ad_proc -public dotlrn_todo::add_user_to_community {
    community_id
    user_id
} {
    No-op
} {
    return
}

ad_proc -public dotlrn_todo::remove_applet {
} {
    Not implemented
} {
    return
}

ad_proc -public dotlrn_todo::remove_user {
    user_id
} {
    No-op
} {
    return
}

ad_proc -public dotlrn_todo::remove_portlet {
    {-portal_id:required}
} {
    Not implemented
} {
    return
}

ad_proc -public dotlrn_todo::remove_applet_from_community {
    community_id
} {
    Not implemented
} {
    return
}

ad_proc -public dotlrn_todo::remove_user_from_community {
    community_id
    user_id
} {
    No-op
} {
    return
}
